<?php

/**
 * reembolso actions.
 *
 * @package    controlComisiones
 * @subpackage reembolso
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class reembolsoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_REEMBOLSO',
        'PROYECTOS'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'PROYECTOS' =>
        array(
            'id_proyecto-id' => 'COM_REEMBOLSO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_REEMBOLSO' =>
        array(
            'id_reembolso' => 'id_reembolso',
            'id_proyecto' => 'id_proyecto',
            'id_anhos' => 'id_anhos',
            'no_reembolso' => 'no_reembolso',
            'fecha_reembolso' => 'fecha_reembolso',
            'estado' => 'estado',
            'fecha_anulacion' => 'fecha_anulacion',
            'motivo_anulacion' => 'motivo_anulacion',
            'observaciones' => 'observaciones',
            'doc_siif' => 'doc_siif',
            'tope'=>'tope'
        ),
        'PROYECTOS' =>
        array(
            'descripcion' => 'descripcion_cm',
            'codigo' => 'codigo_cm'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id_anhos', 'no_reembolso', 'fecha_reembolso', 'estado'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_REEMBOLSO' =>
        array(
            'id_reembolso,a' => array('!=' => array(-1)),
            'id_reembolso,b' => array('=' => array('id_reembolso')),
            'id_proyecto' => array('=' => array('id_proyecto')),
            'id_anhos' => array('=' => array('id_anhos')),
            'estado' => array('=' => array('estado')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_reembolso'; //identificador de la tabla
    protected $id_names = array('id_reembolso'); //llave primaria
    protected $field_names = array('id_proyecto', 'id_anhos', 'no_reembolso', 'fecha_reembolso', 'estado', 'fecha_anulacion', 'motivo_anulacion', 'observaciones', 'doc_siif','tope'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_REEMBOLSO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_reembolso'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {


                $id_reembolso = $list_data_post[0]['id_reembolso'];
                $id_proyecto = $list_data_post[0]['id_proyecto'];
                $id_anhos = $list_data_post[0]['id_anhos'];
                //20170922 Actualizada la consulta para que tomara tambien los pagos de las comisiones abiertas
                //se quito la siguiente consicion del where  and tab6.id_cierre is not null
                $sql = "SELECT ID_PAGO_EGRESO,ID_RUBRO,ID_OBJ_GASTO,VALOR_CUENTA - VALOR_REINTEGRO AS VALOR

                    FROM(

                    select tab0.ID_PAGO_EGRESO,tab1.ID_RUBRO,tab1.ID_OBJ_GASTO,nvl(tab1.VALOR_CUENTA,0) AS VALOR_CUENTA, nvl(tab5.valor,0) as valor_reintegro

                    from com_pago_egreso tab0 
                    join com_deta_cuenta tab1 ON tab1.id_cuenta = tab0.id_cuenta
                    join com_cuenta_v tab2 ON tab2.id_cuenta = tab0.id_cuenta
                    join com_resolucion tab3 ON tab3.id_resolucion = tab2.id_resolucion
                    join COM_COMISION tab4 ON tab4.ID_COMISION = tab3.id_comision
                    left join(
                    select reint.ID_PAGO_EGRESO,deta_rein.ID_OBJ_GASTO,deta_rein.ID_RUBRO,sum(reint.VALOR_TOTAL) valor

                    from COM_REINTEGRO reint 
                    left join COM_DETA_REINTEGRO deta_rein ON deta_rein.id_reintegro = reint.id_reintegro
                    where reint.estado=1
                    group by reint.ID_PAGO_EGRESO, deta_rein.ID_OBJ_GASTO, deta_rein.ID_RUBRO


                    )tab5 ON tab5.id_pago_egreso = tab0.id_pago_egreso and tab5.id_rubro = tab1.id_rubro and tab5.id_obj_gasto = tab1.id_obj_gasto
                    left join com_cierre tab6 ON tab6.id_pago_egreso = tab0.id_pago_egreso
                    
                    where tab4.id_anhos = $id_anhos and tab4.id_proyecto = $id_proyecto

                    and not exists (select deta.* from com_deta_reembolso deta join com_reembolso reemb ON reemb.id_reembolso = deta.id_reembolso and reemb.estado=1 where tab0.ID_PAGO_EGRESO = deta.id_pago_egreso)

                    )";


                $records = CN_TABLE::executeSQL($sql);
                $tope=$request['tope'];
                $monto=0;
                foreach ($records as $records) {

                    $id_obj_gasto = $records['id_obj_gasto'];
                    $id_rubro = $records['id_rubro'];
                    $id_pago_egreso = $records['id_pago_egreso'];
                    $valor = $records['valor'];
                    
                    //20170519 si el monto acumulado no excede el tope en caso de estar establecido realizamos el proceso
                    if((($monto+$valor)<=$tope) or $tope==0){
                        $sql = <<<EOD
            INSERT INTO COM_DETA_REEMBOLSO (ID_REEMBOLSO,ID_RUBRO,ID_OBJ_GASTO,VALOR_REEMBOLSO,ID_PAGO_EGRESO)
               VALUES($id_reembolso,$id_rubro,$id_obj_gasto,$valor,$id_pago_egreso)
EOD;

                        $this->conn->execute($sql);
                        $monto+=$valor;
                    }
                }

                $this->conn->commit();
            } catch (Exception $e) {




                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];

            $request['id_anhos'] = $id_anhos;
            $request['estado'] = 1;
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        $id_proyecto = $request['id_proyecto'];
        $id_anhos = $request['id_anhos'];

        $sql = "SELECT ID_PAGO_EGRESO,ID_RUBRO,ID_OBJ_GASTO,VALOR_CUENTA - VALOR_REINTEGRO AS VALOR

                    FROM(

                    select tab0.ID_PAGO_EGRESO,tab1.ID_RUBRO,tab1.ID_OBJ_GASTO,nvl(tab1.VALOR_CUENTA,0) AS VALOR_CUENTA, nvl(tab5.valor,0) as valor_reintegro

                    from com_pago_egreso tab0 
                    join com_deta_cuenta tab1 ON tab1.id_cuenta = tab0.id_cuenta
                    join com_cuenta_v tab2 ON tab2.id_cuenta = tab0.id_cuenta
                    join com_resolucion tab3 ON tab3.id_resolucion = tab2.id_resolucion
                    join COM_COMISION tab4 ON tab4.ID_COMISION = tab3.id_comision
                    left join(
                    select reint.ID_PAGO_EGRESO,deta_rein.ID_OBJ_GASTO,deta_rein.ID_RUBRO,sum(reint.VALOR_TOTAL) valor

                    from COM_REINTEGRO reint 
                    left join COM_DETA_REINTEGRO deta_rein ON deta_rein.id_reintegro = reint.id_reintegro
                    where reint.estado=1
                    group by reint.ID_PAGO_EGRESO, deta_rein.ID_OBJ_GASTO, deta_rein.ID_RUBRO


                    )tab5 ON tab5.id_pago_egreso = tab0.id_pago_egreso and tab5.id_rubro = tab1.id_rubro and tab5.id_obj_gasto = tab1.id_obj_gasto


                    where tab4.id_anhos = $id_anhos and tab4.id_proyecto = $id_proyecto

                    and not exists (select deta.* from com_deta_reembolso deta join com_reembolso reemb ON reemb.id_reembolso = deta.id_reembolso and reemb.estado=1 where tab0.ID_PAGO_EGRESO = deta.id_pago_egreso)

                    )";


        $records = CN_TABLE::executeSQL($sql);

        if (count($records) == 0) {

            $errors['mensaje'] = "No existe ejecucion para realizar este reembolso";
            $errors['servicio'] = "pago_egreso";
        }


        /*
         *  Validar la operación, ya sea por SQL
         */


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;



        return $errors;
    }

}
